> For the complete documentation index, see [llms.txt](https://docs.getblock.io/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.getblock.io/api-reference/midnight/childstate_getkeyspaged-midnight.md).

# childstate\_getKeysPaged - Midnight

This method returns paged storage keys within a child trie. Use the `startKey` parameter to continue from a previous page.

## Parameters

| Parameter       | Type    | Required | Description                                                |
| --------------- | ------- | -------- | ---------------------------------------------------------- |
| childStorageKey | string  | Yes      | Hex-encoded identifier of the child storage trie           |
| prefix          | string  | Yes      | Hex-encoded key prefix within the child trie               |
| count           | integer | Yes      | Maximum number of keys to return                           |
| startKey        | string  | No       | Hex-encoded key to start from (exclusive)                  |
| hash            | string  | No       | Block hash to query at. Defaults to the current best block |

## Request Example

{% tabs %}
{% tab title="cURL" %}

```bash
curl --location --request POST 'https://go.getblock.io/<ACCESS-TOKEN>/' \
--header 'Content-Type: application/json' \
--data-raw '{
    "jsonrpc": "2.0",
    "method": "childstate_getKeysPaged",
    "params": [
        "0x3a6368696c645f73746f726167653a64656661756c743a",
        "0x",
        100
    ],
    "id": "getblock.io"
}'
```

{% endtab %}

{% tab title="JavaScript (Axios)" %}

```javascript
import axios from 'axios';

const data = JSON.stringify({
    "jsonrpc": "2.0",
    "method": "childstate_getKeysPaged",
    "params": [
        "0x3a6368696c645f73746f726167653a64656661756c743a",
        "0x",
        100
    ],
    "id": "getblock.io"
});

const config = {
    method: 'post',
    url: 'https://go.getblock.io/<ACCESS-TOKEN>/',
    headers: {
        'Content-Type': 'application/json'
    },
    data: data
};

axios(config)
    .then(response => console.log(JSON.stringify(response.data, null, 2)))
    .catch(error => console.log(error));
```

{% endtab %}

{% tab title="Python (Requests)" %}

```python
import requests
import json

url = "https://go.getblock.io/<ACCESS-TOKEN>/"

payload = json.dumps({
    "jsonrpc": "2.0",
    "method": "childstate_getKeysPaged",
    "params": [
        "0x3a6368696c645f73746f726167653a64656661756c743a",
        "0x",
        100
    ],
    "id": "getblock.io"
})

headers = {
    'Content-Type': 'application/json'
}

response = requests.post(url, headers=headers, data=payload)
print(response.text)
```

{% endtab %}

{% tab title="Rust (Reqwest)" %}

```rust
use reqwest::Client;
use serde_json::json;

#[tokio::main]
async fn main() -> Result<(), Box<dyn std::error::Error>> {
    let client = Client::new();

    let payload = json!({
        "jsonrpc": "2.0",
        "method": "childstate_getKeysPaged",
        "params": [
                "0x3a6368696c645f73746f726167653a64656661756c743a",
                "0x",
                100
        ],
        "id": "getblock.io"
});

    let response = client
        .post("https://go.getblock.io/<ACCESS-TOKEN>/")
        .header("Content-Type", "application/json")
        .json(&payload)
        .send()
        .await?;

    let result: serde_json::Value = response.json().await?;
    println!("{:#?}", result);

    Ok(())
}
```

{% endtab %}
{% endtabs %}

## Response Example

{% code overflow="wrap" %}

```json
{
    "jsonrpc": "2.0",
    "id": "getblock.io",
    "result": [
        "0x80\u2026",
        "0x80\u2026"
    ]
}
```

{% endcode %}

## Response Parameters

| Field  | Type            | Description                                          |
| ------ | --------------- | ---------------------------------------------------- |
| result | array of string | Array of hex-encoded child trie keys (up to `count`) |

## Use Cases

* Efficient enumeration of large child tries
* Snapshot generation for contract state
* Memory-bounded indexing pipelines

## Error Handling

| Status Code | Error Message     | Cause                                       |
| ----------- | ----------------- | ------------------------------------------- |
| 403         | Forbidden         | Missing or invalid `<ACCESS-TOKEN>`         |
| -32602      | Invalid params    | Request parameters are missing or malformed |
| 429         | Too Many Requests | Rate limit exceeded for your plan           |

## SDK Integration

{% tabs %}
{% tab title="@polkadot/api (JavaScript)" %}

```javascript
import { ApiPromise, WsProvider } from '@polkadot/api';

const wsProvider = new WsProvider('wss://go.getblock.io/<ACCESS-TOKEN>/');
const api = await ApiPromise.create({ provider: wsProvider });

// Call via the typed API:
const result = await api.rpc.childstate.getKeysPaged("0x3a6368696c645f73746f726167653a64656661756c743a", "0x", 100);
console.log(result.toJSON());

// Or call the raw JSON-RPC method:
const raw = await api.rpc.rpc.methods();
// const raw = await (api as any)._rpcCore.provider.send('childstate_getKeysPaged', ["0x3a6368696c645f73746f726167653a64656661756c743a", "0x", 100]);
```

{% endtab %}

{% tab title="substrate-interface (Python)" %}

```python
from substrateinterface import SubstrateInterface

substrate = SubstrateInterface(url='wss://go.getblock.io/<ACCESS-TOKEN>/')

# Generic RPC call:
result = substrate.rpc_request('childstate_getKeysPaged', ["0x3a6368696c645f73746f726167653a64656661756c743a", "0x", 100])
print(result)
```

{% endtab %}
{% endtabs %}


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.getblock.io/api-reference/midnight/childstate_getkeyspaged-midnight.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
